// Copyright Gäu-Software
// Reuse of this Software is prohibited
var refreshIntervalId = 0;
var lang = "";
var localizedData = [];
var hasSessionStorage = false;
var hasLocalStorage = false;
var type = "";
var data = null;
var queue = "";
var qt = "";
var old = false;
var hf = true;
var path = "";
var isBikeTrial = false;
var isM = false;

function getLocalizedStrings(lang){
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.onreadystatechange = function() {
		if (this.readyState === 4 && this.status == 200) {
			if (this.responseText !== null) {
				localizedData = JSON.parse(this.responseText);
				for (var i = 0; i < Object.keys(localizedData).length; i++) {
					if (document.getElementById(Object.keys(localizedData)[i]) != null)
						document.getElementById(Object.keys(localizedData)[i]).innerHTML = localizedData[Object.keys(localizedData)[i]];
				}
				
				document.getElementById("home-link").href = "index.php?lang=" + lang;
				if (old) {
					alert(localizedData['al-old']);
				}	
				document.getElementById('config-ok').innerHTML = localizedData['ec-login'];				
				document.getElementById('config-lo').innerHTML = localizedData['ec-logout'];
				getCompetition();											
			}
		}
	};
	xmlRequest.open("GET",  "/lang/entry_" + lang + ".json", true);
	xmlRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');	
	xmlRequest.send();
}

function hideLink(lang) {
	document.getElementById("flg-en").style.display = (lang == "en" ? 'none' : 'block');	
	document.getElementById("flg-de").style.display = (lang == "de" ? 'none' : 'block');	
	document.getElementById("flg-cz").style.display = (lang == "cz" ? 'none' : 'block');	
	document.getElementById("flg-fr").style.display = (lang == "fr" ? 'none' : 'block');	
	document.getElementById("flg-es").style.display = (lang == "es" ? 'none' : 'block');	
	document.getElementById("flg-it").style.display = (lang == "it" ? 'none' : 'block');	
}

function hideElements() {
	document.getElementById("header").style.display = 'none';
	document.getElementById("in-nr").style.display = 'none';
	document.getElementById("in-p").style.display = 'none';
	document.getElementById("in-lgn").style.display = 'none';
	document.getElementById("wave").style.display = 'none';
}

function getValue(name) {
	if (hasSessionStorage && sessionStorage.getItem("date") != null && sessionStorage.getItem("date") == getToday()) {
		if (sessionStorage.getItem(name) == null) {
			return "";
		} else {
			return sessionStorage.getItem(name);
		}
	}
	if (getCookie(name) == null) {
		return "";
	} else {
		return getCookie(name);
	}
}

function setValue(name, value) {
	setCookie(name, value);
	if (hasSessionStorage) sessionStorage.setItem(name, value);
}

function deleteValue(name) {
	deleteCookie(name);
	if (hasSessionStorage) sessionStorage.removeItem(name)
}

function loadData() {
	hideElements();

	hasSessionStorage = storageAvailable('sessionStorage');
	hasLocalStorage = storageAvailable('localStorage');
	
	var d = new Date();
	var str = (new Date()).toISOString().slice(0, 10).replace(/-/g, "").substr(2);
	path = window.location.pathname;
	var pos2 = path.lastIndexOf("/");
	var pos1 = path.substr(0, pos2 - 1).lastIndexOf("/");
	var str2 = path.substr(pos1 + 1, 6);
	old = (str2 < str);
	
	lang = getParameterValue("lang");
    if (lang == "") lang = navigator.language || navigator.userLanguage || "de";
	if (lang.length > 2) lang = lang.substr(0, 2); // take first two letters
	if (!((lang == "it") || (lang == "fr") || (lang == "es") || (lang == "en") || (lang == "de") || (lang == "cz"))) {
		lang = "en";
	}

	document.getElementById("flg-img").src = "/img/" + (lang == "en" ? "gb" : lang) + "32.png";
	hideLink(lang);

	if (localizedData.length == 0) getLocalizedStrings(lang);
}

function storageAvailable(type) {
    var storage;
    try {
        storage = window[type];
        var x = '__storage_test__';
        storage.setItem(x, x);
        storage.removeItem(x);
        return true;
    }
    catch(e) {
        return e instanceof DOMException && (
            e.code === 22 ||
            e.code === 1014 ||
            e.name === 'QuotaExceededError' ||
            e.name === 'NS_ERROR_DOM_QUOTA_REACHED') &&
            (storage && storage.length !== 0);
    }
}

function getCompetition(){
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.onreadystatechange = function() {
		if (this.readyState === 4 && this.status == 200) {
			if (this.responseText !== null) {
				var response = this.responseText.split("|")
				if (response.length > 0 && response[0].length > 0) {					
					type = response[0];
					if (hf) {
						document.getElementById('home').src = "/img/" + type + ".png";
						document.getElementById('comp').innerHTML = response[1];
						document.getElementById('run').innerHTML = response[2];
					}
					isBikeTrial = type == "bt";
					if (getValue('code').length > 0 && getValue('arbiter').length > 0) {
						showPage('in-nr');
					} else {
						showPage('in-lgn');
					}
				}
			}
		}
	};
	xmlRequest.open("POST", "comp", true);
	xmlRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	xmlRequest.send();
}

function logout() {
	localStorage.removeItem('slst');
	deleteValue('arbiter');
	deleteValue('code');
	deleteValue('date');
	document.getElementById('in-cl').style.display = 'none';
	document.getElementById('in-lnk').style.display = 'none';
	document.getElementById('config-lo').style.display = 'none';
	
	showPage('in-lgn');
}

function checkLogin() {
	hideElements();
	
	if (!old && (getValue('code').length > 0 && getValue('arbiter').length > 0 && getValue('arbiter') == document.getElementById('ar').value)) {
		document.getElementById('config-lo').style.disaply = 'block';
		var slst = hasLocalStorage ? localStorage.getItem('slst') : document.getElementById('sa').innerHTML;
		if (slst != null && slst.indexOf(";") > 0) {
			var sa = slst.split(";");
			populateSections(sa);
		} else {
			getData();	
		}
		return;
	}
	
	if ((document.getElementById('ar').value == "") ||
		(document.getElementById('code').value == "")) {
		alert(localizedData["em-check2"]);
		logout();
		return;
	}
	
	var xmlRequest = new XMLHttpRequest();
	xmlRequest.onreadystatechange = function() {
		if (this.readyState === 4 && this.status == 200) {
			if (hasLocalStorage)
				localStorage.removeItem('slst');
			if (this.responseText !== null) {
				var respa = this.responseText.split(":");
				if (respa[0] == 0) {					
					setValue('date', getToday());
					setValue('arbiter', document.getElementById('ar').value);
					isM = respa[1] == 1;
					document.getElementById('m-ar').innerHTML = document.getElementById('ar').value + (isM ? ' (' + localizedData['mstr'] + ')' : '');
					setValue('code', respa[2]);		
					document.getElementById('config-lo').style.disaply = 'block';
				} else {
					alert(localizedData["ec-ae" + respa[0]]);
					logout();
				}
			}
		}
	};
	xmlRequest.open("POST", "login", true);
	xmlRequest.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	xmlRequest.send('a=' + btoa(document.getElementById('ar').value) +  
		'&c=' + btoa(document.getElementById('code').value) +
		'&do=auth');
}

function getToday() {
	var today = new Date();
	var dd = today.getDate();
	var mm = today.getMonth() + 1;
	var yyyy = today.getFullYear();

	if (dd < 10) {
		dd = '0' + dd;
	}
	if (mm < 10) {
		mm = '0' + mm;
	}
	
	return yyyy + "" + mm + "" + dd;
}

function getData() {
	var http = new XMLHttpRequest();
	http.onreadystatechange = function() {
		if (this.readyState === 4 && this.status == 200) {
			if (this.responseText !== null) {
				if (this.responseText == "") {
					showPage('in-lgn');
				} else {
					data = JSON.parse(this.responseText);
					if (isM) {
						document.getElementById("em-ec").style.display = 'block';
						document.getElementById("em-ec").disabled = old;
					} else {
						document.getElementById("em-ec").style.display = 'none';
					}
					if (old) {
						document.getElementById("in-lnk").style.display = 'none';
						showPage('in-menu');					
					} else {
						document.getElementById("in-lnk").style.display = 'inline';
						if (isM) {
							showPage('in-menu');
						} else {
							showPage('in-nr');
						}
					}
				}
			}
		}
	};
	http.open("POST", "clss", true);
	http.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	var p = "";
	if (getCookie('code') == null || getCookie('code').length == 0)
		p += '&a=' + getValue('arbiter') + '&c=' + getValue('code');
	http.send(p);
}

function setPageTitle(page) {
	switch (page) {
		case 'in-nr':
			document.getElementById('est-b').style.display = 'none';
			document.getElementById('nr-ti').innerHTML = localizedData["ei-pn"];
			break;
		default:
			break;

	}
}

function toggleFullScreen(full) {
	if (!hf || navigator.userAgent.indexOf("iPad") > 0 || navigator.userAgent.indexOf("iPhone") > 0) return;
	
	var doc = window.document;
	var docEl = doc.documentElement;

	var requestFullScreen = docEl.requestFullscreen || docEl.mozRequestFullScreen || docEl.webkitRequestFullScreen || docEl.msRequestFullscreen;
	var cancelFullScreen = doc.exitFullscreen || doc.mozCancelFullScreen || doc.webkitExitFullscreen || doc.msExitFullscreen;
	var fullscreenElement = doc.fullscreenElement || doc.mozFullScreenElement || doc.webkitFullscreenElement || doc.msFullscreenElement;

	if (full) {
		if (fullscreenElement == null)
			requestFullScreen.call(docEl);
	} else {
		if (fullscreenElement != null)
			cancelFullScreen.call(doc);
	}
}

function showPage(p) {
	page = p;
	hideElements();
	
	if (getValue('code').length == 0) {
		page = 'in-lgn';
	}
	
	setPageTitle(page);
	
	toggleFullScreen (page != 'in-lgn');

	switch (page) {
	case 'in-lgn':
		document.getElementById('ar').value = getValue('arbiter');
		if (hf) {
			document.getElementById('header').style.display = 'block';
			document.getElementById("home-link").style.display = 'block';
		} else {
			document.getElementById("home-link").style.display = 'none';
		}
		break;
		
	case 'in-nr':
		document.getElementById("wave").style.display = 'block';
		if (hf)
			document.getElementById('header').style.display = 'none';
		if (data == null || data.length == 0) getData();
		document.getElementById('noc').disabled = true;
		document.getElementById('nr-nr').innerHTML = "";
		enableNumbers();
		document.getElementById('nr-b').disabled = true;
		break;

	case 'in-p':
		if (hf)
			document.getElementById('header').style.display = 'none';
		document.getElementById('est-b').style.display = 'block';

		var fnr = document.getElementById('nr-nr').innerHTML;
		var ccId = getCompClass(fnr);
		var color = "grey";
		var classname = localizedData["ei-pd"];
		if (ccId != "") {
			classes:
			for (i = 0; i < data.cs.length; i++) {
				if (parseInt(data.cs[i]["id"]) != parseInt(ccId)) continue;
				color = data.cs[i]["c"];
				classname = data.cs[i]["n"];
				break;
			}
		}

		document.getElementById('e-cn').innerHTML = classname;
		document.getElementById('e-pn').innerHTML = fnr;
		document.getElementById('e-ti').setAttribute("class", "nrtitel " + color);
		document.getElementById('e-nr').setAttribute("class", "drno " + color);
		document.getElementById('eh').style.display = 'block';
		if (type == "bt") {
			document.getElementById("in-p-bt").style.display = 'block';	
		} else {
			document.getElementById("in-p-mbt").style.display = 'block';	
		}

		break;
	default:
		document.getElementById('eh').style.display = 'block';
		break;
	}
	
	document.getElementById(page).style.display = 'block';	
}

function enableNumbers() {
	for (j = 0; j < 10; j++) {
		document.getElementById('no' + j).disabled = false;
		document.getElementById('no' + j).setAttribute("class", "nr");
	}
}

function blockNumbers(von, bis) {
	for (j = von; j <= bis; j++) {
		document.getElementById('no' + j).disabled = true;
		document.getElementById('no' + j).setAttribute("class", "nr");
	}
}

function setNumber(k) {
	var fn = document.getElementById('nr-nr').innerHTML;
	document.getElementById('nr-b').disabled = false;
	document.getElementById('noc').disabled = false;

	document.getElementById('nr-nr').innerHTML += k;
	if (fn.length == 2)
		blockNumbers(0, 9);

}

function undoNumber() {
	var fn = document.getElementById('nr-nr').innerHTML;
	
	enableNumbers();
	
	if (fn.length > 1) {
		document.getElementById('nr-nr').innerHTML = fn.substr(0, fn.length - 1);
	} else {
		document.getElementById('nr-nr').innerHTML = "";
		document.getElementById('nr-b').disabled = true;
		document.getElementById('noc').disabled = true;
	}
}

function sendResults(parameters) {
	var http = new XMLHttpRequest();
	http.onreadystatechange = function() {
		document.getElementById('ef-s').disabled = false;
		if (this.readyState === 4 && this.status == 200) {
			var response = this.responseText;
			if (isNaN(response)) {
				alert(localizedData["est-resp"] + response);
				colorWaves(false);
			} else {
				var qa = queue.split("|");
				var newq = "";
				for (var i = 0; i < qa.length; i++) {
					var posf = qa[i].indexOf("&d=" + response + "&");
					console.log("Remove: " + response + " - " + posf + " (" + i + ")");
					if (posf < 0)
						newq += qa[i] + "|";
				}
				queue = newq.substring(0, newq.length - 1);
				if (queue.length > 0) {
					var qa = newq.split("|");
					document.getElementById('qcnt').innerHTML = qa.length;
					sendResults(qa[0]);
				} else {
					document.getElementById('qcnt').innerHTML = "";
				}
				colorWaves(newq.length == 0);
			}
		} else {
			colorWaves(queue.length == 0);
		}
	};
	
	var p = parameters;
	if (p == null) {
		var pn = document.getElementById('e-pn').innerHTML;
		var cid = getCompClass(pn);
		if (cid.length == 0) {
			alert(localizedData['al-dnf'].replace('%s', pn));
			showPage('in-nr');
			return;
		}
	
		document.getElementById('ef-s').disabled = true;
		p = 'cid=' + cid + '&d=' + pn + '&p=' + document.getElementById('s-p').innerHTML;
		if (getCookie('code') == null || getCookie('code').length == 0)
			p += '&a=' + getValue('arbiter') + '&c=' + getValue('code');
		queue += queue.length == 0 ? p : "|" + p;
		document.getElementById('qcnt').innerHTML = queue.split("|").length;
	}
	
	http.open("POST", "points", true);
	http.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
	http.send(p);	

	resetTimer();
	showPage('in-nr');
}

function colorWaves(ok) {
	for (var i = 1; i < 5; i++) {
		var svg = document.getElementById('wave').getSVGDocument();
		if (svg != null) {
			var wave = svg.getElementById("wave" + i);
			wave.setAttribute("stroke", ok ? "green" :  "red");
		}
	}
}

function getCompClass(dnr) {
	if (data == null) return;
	if (data.drvrs != null)
		for (i = 0; i < data.drvrs.length; i++) {
			var drvrsa = data.drvrs[i].split("_");
			if (parseInt(drvrsa[0]) == parseInt(dnr)) {
				return drvrsa[1];
			}
		}
	for (i = 0; i < data.cs.length; i++) {
		var rngsa = data.cs[i].r.split(",");
		for (j = 0; j < rngsa.length; j++) {
			var rnga = rngsa[j].split("-");
			if (parseInt(rnga[0]) <= parseInt(dnr) && parseInt(dnr) <= parseInt(rnga[1])) {
				return data.cs[i].id;
			}
		}
	}
	return "";
}

function createTableHeader(row, laps) {
	var cell1 = row.insertCell();
	for (var i = 0; i < laps.length; i++) {
		var cell2 = row.insertCell();
		cell2.innerHTML = localizedData["cor-r"] + laps[i][0];
		cell2.value = laps[i][0];
		cell2.setAttribute("class", "res");
		var cell3 = row.insertCell();
		cell3.innerHTML = localizedData["cor-new"];
		cell3.setAttribute("class", "res");
	}
}

function createLabelsAndInputFields(row, section, laps, points) {
	var cell1 = row.insertCell();
	cell1.innerHTML = localizedData["cor-s"] + (section + 1);
	cell1.setAttribute("class", "res");
	for (var i = 0; i < laps; i++) {
		var cell2 = row.insertCell();
		cell2.value = section;
		if (points[i] >= 0)
			cell2.innerHTML = points[i];
		cell2.setAttribute("class", "resi");
		var cell3 = row.insertCell();
		var inp = document.createElement("input");
		if (points[i] >= 0) {
			inp.value = points[i];
		}
		inp.setAttribute("class", "res");
		cell3.appendChild(inp);
		cell3.setAttribute("class", "res");
	}
}

function createFields(points) {
	var table = document.getElementById("cor-in");
	for (var j = table.rows.length - 1; j >= 0; j--) {
		table.deleteRow(j);
	}
	if (points == "") return;
	
	var records = points.split("|");	
	var row = table.insertRow(-1);
	createTableHeader(row, records);
	
	var ra = records[0].split(":");
	var pa = ra[1].split(",");
	for (var i = 0; i < pa.length; i++) {		
		if (pa[i] == -99) continue;
		row = table.insertRow(-1);
		var ps = [];
		for (var j = 0; j < records.length; j++) {
			ra = records[j].split(":")
			var psa = ra[1].split(",");
			ps.push(psa[i]);
		}
		createLabelsAndInputFields(row, i, records.length, ps);		
	} 
}

