var jo = null;
var g;
var st;

function qs(key) {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
	if (typeof(vars[key]) == "undefined") {
		return "";
	} else {
		return vars[key];
	}
}

function isPortrait() {
	// returns true, if browser in portrait
	var w = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
	var h = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
	var aspectRatio = w/h;
	return aspectRatio < 16/9;
}

function initialize(){
	// initialize fields
	document.getElementById('nr1').innerHTML = "&nbsp;";
	document.getElementById('n1').innerHTML = "&nbsp;";
	document.getElementById('nr2').innerHTML = "&nbsp;";
	document.getElementById('n2').innerHTML = "&nbsp;";
	document.getElementById('cl').innerHTML = "";
	setClock();
	if (qs('sim') != "") {
		st = Number(qs('sim'));
	} else {
		st = 1;
	}
}

function getData(){
	initialize();
	jo = JSON.parse(data);
	if (jo == null || jo.list == null) return;
	
	var l = jo.list;
	setQ(l, 0);
	
	// set initial start time
	var h, m, sec;
	var start = jo.list[0].t;
	if (st > 1) {
		var t = start.split(":");
		h = Number(t[0]);
		m = Number(t[1]) - 1;
		if (m < 0) {
			if (h == 0) {
				h = 23;
			} else {
				h--;
			}
			m = 60 + m;
		}
		sec = (t.length == 3) ? Number(t[2]) : 0;
	} else {
		var d = new Date();
		h = d.getHours();
		m = d.getMinutes();
		sec = d.getSeconds();
	}
	var zeit = formatClock(h, m, 0, true, true);
	
	// set initial group
	g = 0;
	for (i = 0; i < l.length; i++) {
		g++;
		if (l[i].t < zeit) continue;
		g--;
		break;
	}
	if (g == l.length) g = 0;
	
	setQ(l, g);

	// initial clock
	document.getElementById('cl').innerHTML = formatClock(h, m, sec, false, false);
	// set initial starters
	setStarter(formatTimer(h, m, sec), jo.list);

}

function setClock(){
	if (document.getElementById('cl') == null) {
		return null;
	}

	var h, m, s;
	// for simulation purposes use the given time over the real time
	if (st > 1) {
		var t = document.getElementById('cl').innerHTML.split(":");
		s = (Number(t[2]) + 1) % 60;
		m = (s == 0 ) ? (Number(t[1]) + 1) % 60 : Number(t[1]);;
		h = ((m == 0 ) && (s == 0 )) ? (Number(t[0]) + 1) % 24 : Number(t[0]);
	} else {
		var d = new Date();
		s = d.getSeconds();
		h = d.getHours();
		m = d.getMinutes();
	}
	
	document.getElementById('cl').innerHTML = formatClock(h, m, s, false, false);
	
	return formatTimer(h, m, s);
}

function formatTimer (h, m, s) {
	h = (h == 0) ? "" : ((h < 10) ? "0" + h : h) + ":";
	m = (m < 10) ? "0" + m : m;
	s = (s < 10) ? "0" + s : s;

	return h + m + ":" + s;
}

function formatClock (h, m, s, lz, wos) {
	if (lz) {
		h = (h < 10) ? "0" + h : h;
	}
	m = (m < 10) ? "0" + m : m;
	s = (s < 10) ? "0" + s : s;

	return h + ":" + m + ((wos) ? "" : (":" + s));
}

function cleanQ() {
	var tbl = document.getElementById("q");
	for(var i = tbl.rows.length; i > 0; i--)
	{
		tbl.deleteRow(i - 1);
	}
}

function setQ(l, gi) {
	// show participants who wait in line, number of lines to show can be chosen
	var cnt = (qs('ws') != "") ? Number(qs('ws')) : 15;
	var show = Math.min(cnt, l.length - gi);
	// create table for queue
	var tbl = document.getElementById("q");
	// first clear the table
	cleanQ();
	// then create new table
	var t, w;
	for (var s = 0; s < show; s++) {
		var row = tbl.insertRow();
		row.setAttribute("class", "tq");
		var cell1 = row.insertCell(0);
		var cell2 = row.insertCell(1);
		var ind = gi + s;
		if (isPortrait()) {
			t = l[ind].t; 
			w = "<b>" + l[ind].g[0].no + '</b> ' + l[ind].g[0].na;
			if (l[ind].g.length > 1) {
				t += "<br>"; 
				w += "<br><b>" + l[ind].g[1].no + '</b> ' + l[ind].g[1].na;
				if (l[ind].g.length > 2)
					w += "<br><b>" + l[ind].g[2].no + '</b> ' + l[ind].g[2].na;
			}
		} else {
			w = ((l[ind].g.length > 1) ? " <b>" + l[ind].g[1].no + '</b> ' + l[ind].g[1].na : "");
			t = l[ind].t + " <b>" + l[ind].g[0].no + '</b> ' + l[ind].g[0].na;
			if (l[ind].g.length > 2) {
				w += "<br><b>" + l[ind].g[2].no + '</b> ' + l[ind].g[2].na;
			}
		}
		cell1.innerHTML = t;
		cell2.innerHTML = w;
	}
	g = gi;

}

function setStarter(ct){
	var l = jo.list;
	
	if (l[g] == null) {
		// group g is not available in list, done
		for (s = 1; s < 3; s++) {
			document.getElementById('nr' + s).innerHTML = "&nbsp;";
			document.getElementById('n' + s).innerHTML = "&nbsp;";
		}
		return;
	}
	
	var stt = l[g].t; // start time of group g
	var wos = true;
	
	if (l[g].t.indexOf(":") == l[g].t.lastIndexOf(":")) {
		stt += ":00" // work with seconds
		wos = false;
	}
	
	if (ct.lastIndexOf(":00") == 5 || (wos && ct.lastIndexOf(":30") == 5)) {
		// we reached a minute or half minute flip, reset the starter values
		for (s = 1; s < 3; s++) {
			document.getElementById('nr' + s).innerHTML = "&nbsp;";
			document.getElementById('n' + s).innerHTML = "&nbsp;";
		}
		if (ct.indexOf(stt) == 0) {
			// time over update green starter field
			// first column always
			document.getElementById('nr1').innerHTML = l[g].g[0].no;
			document.getElementById('n1').innerHTML = l[g].g[0].na;
			var length = l[g].g.length;
			var col2no = "";
			var col2na = "";
			// second column
			if (length > 1) {
				col2no = l[g].g[1].no;
				col2na = l[g].g[1].na;
			}
			if (length > 2) {
				col2no += " " + col2na;
				col2na = l[g].g[2].no + " " + l[g].g[2].na;
			} else {
			}
			document.getElementById('nr2').innerHTML = col2no;
			document.getElementById('n2').innerHTML = col2na;
			g++; // next starting group in queue
			if (l[g] != null) {
				setQ(l, g);
			} else {
				cleanQ();
				g = 0;
				// no more starters -> only update clock
				clearInterval(riid);
				if (st == 1) {
					// when not simulating we continue to show the clock
					updtTo();
					riid = setInterval(updtTo, 1000);
				}
				return; 
			}
		}
	}
}

function updt(){
	// update clock
	var t = setClock();
	// update starter every 10 seconds
	if (t !== null && (Number(t.substr(t.lastIndexOf(":") + 1)))%10 == 0) {
		setStarter(t);
	}
}

function updtTo(){
	// update clock only
	setClock();
}

updt();
var riid = setInterval(updt, (qs('sim') != "") ? 1000/Number(qs('sim')) : 1000);
